// Imagine++ project
// Project:  matrices3
// Author:   keriven
// Date:     2007/10/19

#include <iostream>
#include <string>
using namespace std;

//==================================================
// functions on matrices
// could be in matrix.h and matrix.cpp

// ========= declarations (in .h)
struct Matrix {
    int m,n;
    double* t;
    void create(int m1,int n1);
    void destroy();
    double get(int i,int j);
    void set(int i,int j,double x);
    void display(string s);
};
Matrix operator*(Matrix A,Matrix B);

// ========= definitions (in .cpp)
void Matrix::create(int m1,int n1) {
    // Note the parameters are not called m and n
    // to avoid confusion with fields!
    m=m1;
    n=n1;
    t=new double[m*n];
}

void Matrix::destroy() {
    delete[] t;
}

double Matrix::get(int i,int j) {
    return t[i+m*j];
}

void Matrix::set(int i,int j,double x) {
    t[i+m*j]=x;
}

void Matrix::display(string s) {
    cout << s << " =" << endl;
    for(int i=0; i<m; i++) {
        for(int j=0; j<n; j++)
            cout << get(i,j) << " ";
        cout << endl;
    }
}

Matrix operator*(Matrix A,Matrix B) {
    if(A.n!=B.m) {
        cout << "Error!" << endl;
        exit(1);
    }
    Matrix C;
    C.create(A.m,B.n);
    for(int i=0; i<A.m; i++)
        for(int j=0; j<B.n; j++) {
            // Cij=Ai0*B0j+Ai1*B1j+...
            C.set(i,j,0);
            for(int k=0; k<A.n; k++)
                C.set(i,j,
                      C.get(i,j)+A.get(i,k)*B.get(k,j));
        }
    return C;
}

// ==================== main ===========
int main()
{
    Matrix A;
    A.create(2,3);
    for(int i=0; i<2; i++)
        for(int j=0; j<3; j++)
            A.set(i,j,i+j);
    A.display("A");
    Matrix B;
    B.create(3,5);
    for(int i=0; i<3; i++)
        for(int j=0; j<5; j++)
            B.set(i,j,i+j);
    B.display("B");
    Matrix C=A*B;
    C.display("C");
    C.destroy();
    B.destroy();
    A.destroy();
    return 0;
}
